#include "homedir_platform.h"

#include <string>
#include <Shlobj.h>


HomeDir_platform::HomeDir_platform()
{
}

string HomeDir_platform::get()
{
  string ret = "";
  PWSTR str;

  //ziskani domovske cesty
  if (SHGetKnownFolderPath(FOLDERID_Profile, 0, NULL, &str) == S_OK)
  {
    //prevedeni na UTF-8, prvne zjisteni utf-8-velikosti
    int sz = WideCharToMultiByte(CP_UTF8, 0, str, -1, NULL, 0, NULL, NULL);
      //pozn.: To, ze vyse pouzita funkce vraci int, neni moje chyba
    if (sz)
    {
      char *out = new char[sz];
      //samotna konverze do utf-8
      if (WideCharToMultiByte(CP_UTF8, 0, str, -1, out, sz, NULL, NULL))
        ret = out;
      delete[] out;
    } 
  }
  CoTaskMemFree(&str);

  //vraceni vysledku
  return ret;
}
